package dev.fyloz.trial.colorrecipesexplorer.exception.model

import dev.fyloz.trial.colorrecipesexplorer.exception.RestException
import dev.fyloz.trial.colorrecipesexplorer.model.Model
import org.springframework.http.HttpStatus
import org.springframework.web.bind.annotation.ResponseStatus

class EntityNotFoundException(
    modelType: Class<out Model>,
    val identifierType: IdentifierType,
    val requestedId: Any
) : ModelException(modelType)

@ResponseStatus(HttpStatus.NOT_FOUND)
class EntityNotFoundRestException(val value: Any) :
    RestException("An entity could not be found with the given identifier", HttpStatus.NOT_FOUND) {

    @Suppress("unused")
    override fun buildBody(): RestExceptionBody = object : RestExceptionBody() {
        val id = value
    }
}
