# v1.3.1
### Corrections
* Il était impossible d'avoir plusieurs mélanges du même nom dans des recettes différentes.
* Les types de produit n'étaient pas validés lors de leur création.
* Il était impossible de modifier les types de produits.
* Il était impossible de créer des PDFs de kit de retouche.
* Les fichiers SIMDUT ne fonctionnaient pas dans la plupart de l'application.
* Les fichiers SIMDUT existant n'étaient pas correctement détectés.
* L'indicateur de statut de l'extension bPac ne s'actualisait parfois pas.
* Aucun message d'erreur ne pouvait s'afficher lors de la création d'un mélange.
* Les recettes n'étaient pas mises à jour lors de leur édition.
* Les quantités n'étaient pas correctement converties en millilitres.
* Un message d'erreur apparaissait lors de la suppression d'une entité, même si l'opération se terminait avec succès.
* Les images et les fichiers SIMDUT étaient dissociés de leur entité lorsque le nom de celle-ci était modifié.
* Les images des recettes s'affichaient au dessus des étapes à certaines résolutions.
* Le bouton "Cacher les autres produits" cachait les produits en manque.
* Le la boite de confirmation n'était pas assez grande pour son contenu.
* Le lien "Exporter toutes les couleurs" du menu principal n'envoyait pas toujours vers la bonne URL.
* Le fichier ZIP généré par l'export de toutes les recettes était corrompu.

### Ajouts
* Le bouton enregistrer de l'explorateur de recette clignote lorsqu'une modification n'est pas sauvegardée.

### Dépendances
* Ajout de jQuery UI. 

# v1.3.0 (Optimisations back-end)
### Note: Cette mise à jour n'est pas compatible avec les anciennes versions.
### Corrections
* Réusinage des modèles. (Améliore la maintenabilité, empêche la compatibilité avec les anciennes versions)
* Réusinage des contrôleurs et des services. (Améliore la maintenabilité et permet d'avoir des messages d'erreur plus précis)
* La recherche de produit dans les sélecteurs de produits dans l'éditeur de mélange est fonctionnelle.
* Correction de quelques bugs visuels dans les menus et l'éditeur de mélange.
* Les caractères spéciaux sont maintenant affichés correctement dans les PDFs et les étiquettes P-touch.

### Ajouts
* Les boites de texte des boites de confirmation prennent le focus automatiquement.
* Appuyez sur Entrer (Enter) lorsqu'une boite de confirmation est présente aura le même effet qu'appuyer sur Continuer.
* Appuyez sur Échapper (Esc) lorsqu'un boite de confirmation est présente aura le même effet qu'appuyer sur Annuler.
* Il n'est plus possible de créer des mélanges dont le type est le même qu'un produit. (Permet d'éviter les conflits)
* Ajout des types de produit par défaut.
    * Ceux-ci ne peuvent pas être modifiés ou supprimés.
    * Ils peuvent être configurés dans les propriétés du serveur. 
    
### Dépendances
* Transition complète vers jQuery.

# v1.2.0 (Imprimante P-touch)
### Corrections
* Correction d'un bug qui empêchait la suppression des mélanges.
* Correction d'un bug qui empêche les boutons supprimer de fonctionner.
* Correction d'un bug qui permettait d'envoyer les formulaires demandant des mots de passe sans donner un mot de passe valide.
* Correction d'une désynchronisation entre le nom des mélanges et leur produit interne.
* Amélioration du style.
* Amélioration de la fluidité de la navigation.
* Transition complète des modèles vers Lombok.

### Ajouts
* Ajout du support pour l'imprimante P-touch de Brother.
  * L'extension b-Pac doit être installée sur le navigateur des clients.
    * [Firefox](https://cre.fyloz.dev/bpac.xpi)
    * [Chrome](https://chrome.google.com/webstore/detail/brother-b-pac-extension/ilpghlfadkjifilabejhhijpfphfcfhb)
  * Le logiciel b-Pac doit être installé sur l'ordinateur des clients.
    * [Windows](https://download.brother.com/welcome/dlfp100614/bcciw32031.msi)
* Ajout de la possibilité d'imprimer les mélanges avec P-Touch
* Ajout de la possibilité d'imprimer les étiquettes de kit de retouche avec P-Touch
* Ajout des boîtes de confirmation.
* Ajout d'un type de produit aux mélanges.
* Ajout du changement d'ordre des produits d'un mélange.
* Les produits dans l'inventaire sont maintenant ordonnés alphabétiquement.

### Dépendances
* Ajout de jQuery, début de la transition.
* Migration vers Java 11.

# v1.1.3
### Corrections
* Correction de fautes de syntaxe.
* Correction d'un bug qui empêchait d'utiliser une recette.

### Ajouts
* Traduction complète de l'application.
* Amélioration des recherches.
* Ajout d'une confirmation avant l'utilisation d'un mélange ou d'une recette.
* Le nom des mélanges peut maintenant être modifié.
* Le bouton retour envoie maintenant vers la dernière page visitée.

# v1.1.2
### Corrections
* Amélioration du style du site.
* Correction d'un bug qui permettait de supprimer des images sans mot de passe.

### Ajouts
* Il n'est plus possible de modifier la quantité des produits utilisant les pourcentages dans l'explorateur de recette.
* La quantité initiale d'un produit peut maintenant être cachée dans l'explorateur de recette. 
* La quantité minimum d'un produit dans un mélange est maintenant de 0.001.
* La quantité de chaque produit d'un mélange peut maintenant être calculée depuis la quantitée totale du mélange.
* Ajout de boîtes de notification améliorées.

# v1.1.1
### Corrections
* Désactivation de l'autocomplétion dans les étapes des recettes (permet d'éviter un bug qui affiche les suggestion par dessus toutes les étapes sur Edge)
* Correction d'un bug qui permettait d'envoyer les formulaires demandant des mots de passe sans donner un mot de passe valide.
* Amélioration des contrôleurs et du service des mélanges.
* Correction d'un bug avec la création des mélanges.

### Ajouts
* L'onglet se ferme automatiquement lorsqu'un utilisateur tente d'accéder à un fichier SIMDUT inexistant.
* Meilleure sélection des produits dans l'éditeur de mélange.
* Amélioration de l'affichage de la plupart des tables, les rendant moins chargées.
* Amélioration de l'affichage des étapes et des images dans l'explorateur et l'éditeur de recette.
* Ajout de la page de l'historique des mises à jour.
* Ajout de la journalisation.

### Dépendances
* Ajout de Lombok
